// {wb_t@ĆCMicrochipЃIWĩwb_t@Cadc.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>

/* AD1CON1 rbg` */

#define ADC_MODULE_ON               0xFFFF /* A/DW[I */
#define ADC_MODULE_OFF              0x7FFF /* A/DW[It */

#define ADC_IDLE_CONTINUE           0xDFFF /* idle[hɂA/DW[I */
#define ADC_IDLE_STOP               0xFFFF /* idle[hɂA/DW[It */

#define ADC_ADDMABM_ORDER           0XFFFF /* DMA RAM AhXAD ϊƂ */
#define ADC_ADDMABM_SCATTR          0xEFFF /* DMA RAM AhXCH ɕʁXɐݒ肷 */

#define ADC_AD12B_12BIT             0xFFFF /* 12 rbgAD ϊI */
#define ADC_AD12B_10BIT             0xFBFF /* 10 rbgAD ϊI */

#define ADC_FORMAT_SIGN_FRACT       0xFFFF /* tŒ菬_ */
#define ADC_FORMAT_FRACT            0xFEFF /* ȂŒ菬_ */
#define ADC_FORMAT_SIGN_INT         0xFDFF /* t */
#define ADC_FORMAT_INTG             0xFCFF /* Ȃ */

#define ADC_CLK_AUTO                0xFFFF /* JԂTvO */
#define ADC_CLK_MPWM                0xFF7F /* PWM1 ɓăz[h & AD ϊ */
#define ADC_CLK_TMR                 0xFF5F /* ^C} 3 ɓăz[h & AD ϊ */
#define ADC_CLK_INT0                0xFF3F /* INT0(16 ԃsɓăz[h & AD ϊ */
#define ADC_CLK_MANUAL              0xFF1F /* SAMP = 0 ɂz[h & AD ϊ */

#define ADC_SIMULTANEOUS            0xFFFF /* CH0?CH3 𓯎Ƀz[h & AD ϊ */
#define ADC_MULTIPLE                0XFFF7 /* CH0?CH3 Ƀz[h & ADϊ*/

#define ADC_AUTO_SAMPLING_ON        0xFFFF /* AD ϊIƎIɎ̃TvJn */
#define ADC_AUTO_SAMPLING_OFF       0xFFFB /* SAMP = 1 ɂTvJn */

#define ADC_SAMP_ON                 0xFFFF /* TvOJn */
#define ADC_SAMP_OFF                0xFFFD /* z[h & AD ϊ*/
                                           

/* AD1CON2@rbg` */
#define ADC_VREF_AVDD_AVSS          0x0FFF /* ADREF+ = AVDD, ADREF- = AVSS */
#define ADC_VREF_EXT_AVSS           0x2FFF /* ADREF+ = External VREF+, ADREF- = AVSS */
#define ADC_VREF_AVDD_EXT           0x4FFF /* ADREF+ = AVDD, ADREF- = External VREF- */
#define ADC_VREF_EXT_EXT            0x6FFF /* ADREF+ = External VREF+, ADREF- = External VREF- */

#define ADC_SCAN_ON                 0xEFFF /* Scan[hgp */
#define ADC_SCAN_OFF                0xEBFF /* Scan[hsgp */

#define ADC_SELECT_CHAN_0123        0xEFFF /* CH0?CH3 I */
#define ADC_SELECT_CHAN_01          0xEDFF /* CH0, CH3 I */
#define ADC_SELECT_CHAN_0           0xECFF /* CH0 I */


                                    /* BUFM = 1̂Ƃ̂ݗL*/
#define ADC_BUF_FILL_0x8_0xF        0xEFFF /*ADϊ킪obt@ 0x8-0xFɃf[^]*/
#define ADC_BUF_FILL_0x0_0x7        0xEF7F /*ADϊ킪obt@ 0x0-0x7Ƀf[^] */

#define ADC_DMA_ADD_INC_1           0xEFC3 /* Scan[hłȂƂ */
#define ADC_DMA_ADD_INC_2           0xEFC7 /* Scan[hɂāCScan`l 2 ̂Ƃ */
#define ADC_DMA_ADD_INC_3           0xEFCB /* Scan[hɂāCScan`l 3 ̂Ƃ */
#define ADC_DMA_ADD_INC_4           0xEFCF /* Scan[hɂāCScan`l 4 ̂Ƃ */


#define ADC_ALT_BUF_ON              0xEFFF /* DMA RAM obt@̔ёSꂽ_Ŋ荞 */
#define ADC_ALT_BUF_OFF             0xEFFD /* DMA RAM obt@̑Sꂽ_Ŋ荞 */


#define ADC_ALT_INPUT_ON            0xEFFF /* (CHCNA, CH0NA,EEE)  (CH0SB, CH0NB, EEE) Tvɐؑւ */
#define ADC_ALT_INPUT_OFF           0xEFFE /* (CHCNA, CH0NA,EEE) p */

/* AD1CON3@rbg` */
#define ADC_CONV_CLK_INTERNAL_RC    0xFFFF /* ADC  RC NbN𗘗p */
#define ADC_CONV_CLK_SYSTEM         0x7FFF /*foCXCXgNVNbN Fcy 𗘗p*/


                                    /* Tsamp ( = TvO) ̐ݒ@Tsamp̍ŏl̓f[^V[gADC Conversion Timing RequirementQ*/
#define ADC_SAMPLE_TIME_0           0xE0FF /* Tsamp = 0 Tad */
#define ADC_SAMPLE_TIME_1           0xE1FF /* Tsamp = 1 Tad */
#define ADC_SAMPLE_TIME_2           0xE2FF /* Tsamp = 2 Tad */
#define ADC_SAMPLE_TIME_3           0xE3FF /* Tsamp = 3 Tad */
#define ADC_SAMPLE_TIME_4           0xE4FF /* Tsamp = 4 Tad */
#define ADC_SAMPLE_TIME_5           0xE5FF /* Tsamp = 5 Tad */
#define ADC_SAMPLE_TIME_6           0xE6FF /* Tsamp = 6 Tad */
#define ADC_SAMPLE_TIME_7           0xE7FF /* Tsamp = 7 Tad */
#define ADC_SAMPLE_TIME_8           0xE8FF /* Tsamp = 8 Tad */
#define ADC_SAMPLE_TIME_9           0xE9FF /* Tsamp = 9 Tad */
#define ADC_SAMPLE_TIME_10          0xEAFF /* Tsamp = 10 Tad */

#define ADC_SAMPLE_TIME_31          0xFFFF /* Tsamp = 31 Tad */



                                   /* Tad̐ݒC@Tad̍ŏl̓f[^V[gADC Conversion Timing RequirementQ*/
#define ADC_CONV_CLK_256Tcy        0xFFFF /* Tad = 256Tcy */ 

#define ADC_CONV_CLK_64Tcy         0xFF3F /* Tad = 64Tcy */  

#define ADC_CONV_CLK_4Tcy          0xFF03 /* Tad = 4Tcy */
#define ADC_CONV_CLK_3Tcy          0xFF02 /* Tad = 3Tcy */
#define ADC_CONV_CLK_2Tcy          0xFF01 /* Tad = 2Tcy */  
#define ADC_CONV_CLK_1Tcy          0xFF00 /* Tad = Tcy */


/* AD1CON4 rbg` */
#define ADC_DMA_BUF_LOC_128         0xFFFF /* DMAobt@ɃAiO͖128[h蓖Ă */
#define ADC_DMA_BUF_LOC_64          0xFFFE /* DMAobt@ɃAiO͖ 64[h蓖Ă */
#define ADC_DMA_BUF_LOC_32          0xFFFD /* DMAobt@ɃAiO͖ 32[h蓖Ă */
#define ADC_DMA_BUF_LOC_16          0xFFFC /* DMAobt@ɃAiO͖ 16[h蓖Ă */
#define ADC_DMA_BUF_LOC_8           0xFFFB /* DMAobt@ɃAiO͖  8[h蓖Ă */
#define ADC_DMA_BUF_LOC_4           0xFFFA /* DMAobt@ɃAiO͖  4[h蓖Ă */
#define ADC_DMA_BUF_LOC_2           0xFFF9 /* DMAobt@ɃAiO͖  2[h蓖Ă */
#define ADC_DMA_BUF_LOC_1           0xFFF8 /* DMAobt@ɃAiO͖  1[h蓖Ă */


/* AD1CHS123 rbg` */
#define ADC_CH123_NEG_SAMPLEB_9_10_11  0xFFFF /* TvBÎƂCCH1, 2, 3 ̃obt@Av́|ɂꂼ AN9, AN10, AN11 Ȃ*/
#define ADC_CH123_NEG_SAMPLEB_6_7_8    0xFDFF /* TvBÎƂCCH1, 2, 3 ̃obt@Av́|ɂꂼ AN6, AN7, AN8 Ȃ*/
#define ADC_CH123_NEG_SAMPLEB_VREFN    0xF9FF /* TvBÎƂCCH1, 2, 3 ̃obt@Av́|VREFL Ȃ*/

#define ADC_CH123_POS_SAMPLEB_3_4_5    0xFFFF /* TvBÎƂCCH1, 2, 3 ̃obt@Av+ɂꂼ AN3, AN4, AN5 Ȃ*/
#define ADC_CH123_POS_SAMPLEB_0_1_2    0xFEFF /* TvBÎƂCCH1, 2, 3 ̃obt@Av+ɂꂼ AN0, AN1, AN2 Ȃ*/

#define ADC_CH123_NEG_SAMPLEA_9_10_11  0xFFFF /* TvAÎƂCCH1, 2, 3 ̃obt@Av́|ɂꂼ AN9, AN10, AN11 Ȃ*/
#define ADC_CH123_NEG_SAMPLEA_6_7_8    0xFFFD /* TvAÎƂCCH1, 2, 3 ̃obt@Av-ɂꂼ AN6, AN7, AN8 Ȃ*/
#define ADC_CH123_NEG_SAMPLEA_VREFN    0xFFF9 /* TvAÎƂCCH1, 2, 3 ̃obt@Av́|VREFL Ȃ*/

#define ADC_CH123_POS_SAMPLEA_3_4_5    0xFFFF /* TvAÎƂCCH1, 2, 3 ̃obt@Av+ɂꂼ AN3, AN4, AN5 Ȃ*/
#define ADC_CH123_POS_SAMPLEA_0_1_2    0xFFFE /* TvAÎƂCCH1, 2, 3 ̃obt@Av+ɂꂼ AN0, AN1, AN2 Ȃ*/


/* AD1CHS0 rbg` */
#define ADC_CH0_NEG_SAMPLEB_AN1     0xFFFF /* TvBÎƂCCH0 ̃obt@Av́| AN1 Ȃ */
#define ADC_CH0_NEG_SAMPLEB_VREFN   0x7FFF /* TvBÎƂCCH0 ̃obt@Av́| VREFL Ȃ */


#define ADC_CH0_POS_SAMPLEB_AN31    0xFFFF /* TvBÎƂCCH0 ̃obt@Av́{ AN31 Ȃ */

#define ADC_CH0_POS_SAMPLEB_AN5     0xE5FF /* TvBÎƂCCH0 ̃obt@Av́{ AN5 Ȃ */
#define ADC_CH0_POS_SAMPLEB_AN4     0xE4FF /* TvBÎƂCCH0 ̃obt@Av́{ AN4 Ȃ */
#define ADC_CH0_POS_SAMPLEB_AN3     0xE3FF /* TvBÎƂCCH0 ̃obt@Av́{ AN3 Ȃ */
#define ADC_CH0_POS_SAMPLEB_AN2     0xE2FF /* TvBÎƂCCH0 ̃obt@Av́{ AN2 Ȃ */
#define ADC_CH0_POS_SAMPLEB_AN1     0xE1FF /* TvBÎƂCCH0 ̃obt@Av́{ AN1 Ȃ */
#define ADC_CH0_POS_SAMPLEB_AN0     0xE0FF /* TvBÎƂCCH0 ̃obt@Av́{ AN0 Ȃ */

#define ADC_CH0_NEG_SAMPLEA_AN1     0xFFFF /*TvAÎƂCCH0 ̃obt@Av́| AN1 Ȃ */
#define ADC_CH0_NEG_SAMPLEA_VREFN   0xFF7F /*TvAÎƂCCH0 ̃obt@Av́| VREFL Ȃ */


#define ADC_CH0_POS_SAMPLEA_AN31    0xFFFF  /* TvAÎƂCCH0 ̃obt@Av́{ AN31 Ȃ */
   
#define ADC_CH0_POS_SAMPLEA_AN5     0xFFE5  /* TvAÎƂCCH0 ̃obt@Av́{ AN5 Ȃ */   
#define ADC_CH0_POS_SAMPLEA_AN4     0xFFE4  /* TvAÎƂCCH0 ̃obt@Av́{ AN4 Ȃ */   
#define ADC_CH0_POS_SAMPLEA_AN3     0xFFE3  /* TvAÎƂCCH0 ̃obt@Av́{ AN3 Ȃ */   
#define ADC_CH0_POS_SAMPLEA_AN2     0xFFE2  /* TvAÎƂCCH0 ̃obt@Av́{ AN2 Ȃ */   
#define ADC_CH0_POS_SAMPLEA_AN1     0xFFE1  /* TvAÎƂCCH0 ̃obt@Av́{ AN1 Ȃ */   
#define ADC_CH0_POS_SAMPLEA_AN0     0xFFE0  /* TvAÎƂCCH0 ̃obt@Av́{ AN0 Ȃ */   


/*AD1CSSL rbg` */
#define SKIP_SCAN_AN0                   0xFFFE /*Scan[h AN0 ScanȂ */
#define SKIP_SCAN_AN1                   0xFFFD /*Scan[h AN1 ScanȂ */    
#define SKIP_SCAN_AN2                   0xFFFB /*Scan[h AN2 ScanȂ */
#define SKIP_SCAN_AN3                   0xFFF7 /*Scan[h AN3 ScanȂ */
#define SKIP_SCAN_AN4                   0xFFEF /*Scan[h AN4 ScanȂ */
#define SKIP_SCAN_AN5                   0xFFDF /*Scan[h AN5 ScanȂ */    

#define SKIP_SCAN_AN15                  0x7FFF /*Scan[h AN15 ScanȂ */
 
#define SCAN_NONE_0_15                  0x0000 /*Scan[h AN0?AN15 ScanȂ */
#define SCAN_ALL_0_15                   0xFFFF /*Scan[h AN0?AN15 Scan */


/* AD1PCFGL rbg` */
#define ENABLE_AN0_ANA                  0xFFFE /*AN0p|[g (2 ԃsjAiO[hݒƂ */
#define ENABLE_AN1_ANA                  0xFFFD /*AN1p|[g (3 ԃsjAiO[hݒƂ */
#define ENABLE_AN2_ANA                  0xFFFB /*AN2p|[g (4 ԃsjAiO[hݒƂ */
#define ENABLE_AN3_ANA                  0xFFF7 /*AN3p|[g (5 ԃsjAiO[hݒƂ */
#define ENABLE_AN4_ANA                  0xFFEF /*AN4p|[g (6 ԃsjAiO[hݒƂ */
#define ENABLE_AN5_ANA                  0xFFDF /*AN5p|[g (7 ԃsjAiO[hݒƂ */

#define ENABLE_ALL_ANA_0_15             0xFFC0 /*AN0-AN5p|[gAiO[hݒƂ */
#define ENABLE_ALL_DIG_0_15             0xFFFF /*AN0-AN5p|[gfBW^[hݒƂ */


/* ADCI荞݂̗Dx` */
#define ADC_INT_PRI_0                   0xFFF8 //Dx0@荞ݕs
#define ADC_INT_PRI_1                   0xFFF9 // Dx@Œ
#define ADC_INT_PRI_2                   0xFFFA
#define ADC_INT_PRI_3                   0xFFFB
#define ADC_INT_PRI_4                   0xFFFC
#define ADC_INT_PRI_5                   0xFFFD
#define ADC_INT_PRI_6                   0xFFFE
#define ADC_INT_PRI_7                   0xFFFF // Dx@ō


/* ADCI荞݉^s` */
#define ADC_INT_ENABLE                  0xFFFF
#define ADC_INT_DISABLE                 0xFFF7

/* AD1CON2@SMPIrbg̒` */
#define ADC_SAMPLES_PER_INT_1           0xEFC3  /* ADϊ1IɊ荞 */
#define ADC_SAMPLES_PER_INT_2           0xEFC7  /* ADϊ2IɊ荞 */
#define ADC_SAMPLES_PER_INT_3           0xEFCB  /* ADϊ3IɊ荞 */
#define ADC_SAMPLES_PER_INT_4           0xEFCF  /* ADϊ4IɊ荞 */

#define ADC_SAMPLES_PER_INT_16          0xEFFF  /* ADϊ18IɊ荞 */


/* ADC ֐vg^Cvi錾j */
void ConfigIntADC802(unsigned int a);

