/*********************************************
PWM + QEI + IC eXgvOi12rbgxj
**********************************************/
#include <p33fj128mc802.h>
#include ".\include\declaration_of_variables.h"

// foCXRtBM[V
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ

void init_DMA1(void);
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);
void init_QEI(void);
void init_IC(void);
void init_timer2(void);

//C֐
int main(void)
{
    //PLLݒ
        _PLLPRE   =  0;     // N1 =  2
        _PLLDIV   = 42;     //  M = 44
        _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz
        _SWDTEN = 0;                    //EHb`hbO^C}It
        while(OSCCONbits.LOCK !=1 );   	// PLLbN҂

	// I/O |[gݒ
        TRISA = 	0x0001;                 // RA0 , RA1 - 5 o̓|[gݒ
        TRISB = 	0b0000000111000000;		// RB6-8 ̓|[gݒ
	
	// SPIp|[gݒ
        _RP11R =  8;			//RP11  SCK (01000) Ɋ蓖
        _RP10R =  7;			//RP10  SDO (00111)Ɋ蓖
    
   	// QEIp|[gݒ
        _QEA1R = 7;             // QEA1R @RP7 Ɋ蓖
        _QEB1R = 6;             // QEB1R @RP6 Ɋ蓖

    //ICp|[gݒ
        _IC1R = 8;              // IC1R  RP8 Ɋ蓖		

        // ӃW[ݒ
	init_DMA1();            // DMAݒ	
	init_SPI();             // SPIݒ
	init_ADC();             // ADCݒ
    init_PWM();             // MCPWM ݒ
    init_QEI();            	// QEIݒ
    init_IC();              // ICݒ
    init_timer2();          // timer2ݒ
    
	//[v
	while(1){}
}


