#include <p33fj128mc802.h>
#include ".\include\pwm802.h"

// PWMW[ݒ֐
void init_PWM(void)
{
    extern const unsigned int PWMPeriod;

    unsigned int P1TCON_set = PWM1_EN           & PWM1_IDLE_STOP 
                            & PWM1_OP_SCALE1    & PWM1_IPCLK_SCALE1 
                            & PWM1_MOD_UPDN;   	
    unsigned int PWM1CON1_set = PWM1_MOD3_IND   & PWM1_MOD2_IND 
                            & PWM1_MOD1_COMP	& PWM1_PDIS3L 
                            & PWM1_PDIS3H       & PWM1_PDIS2L 
                            & PWM1_PDIS2H		& PWM1_PEN1L 
                            & PWM1_PEN1H;
    unsigned int PWM1CON2_set = PWM1_SEVOPS1    & PWM1_UEN;
    
    P1TCON   = P1TCON_set;
    PWM1CON1 = PWM1CON1_set;
    PWM1CON2 = PWM1CON2_set;
    P1TPER   = PWMPeriod-1;
    P1SECMP  = 0;                // PWM1_SEVOPS1 CADϊP1TMR = P1SECMP = 0ƂȂ^C~OɎs   
    
    P1OVDCON = 0xFFFF;           // I[o[Chsgp
}


