// {wb_t@ĆCMicrochipЃIWĩwb_t@Cspi.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>

/* SPI1CON1 rbg` */
#define DISABLE_SCK_PIN         0xffff  /* (}X^[[h) SCK s SPI W[ł͎gpsƂCI/O psƂD */
#define ENABLE_SCK_PIN          0xefff  /* (}X^[[h) SCK s SPI W[pƂ */


#define  DISABLE_SDO_PIN        0xffff  /* SDO s SPI W[ł͎gpsƂCI/O psƂ   */
#define  ENABLE_SDO_PIN         0xf7ff  /* SDO s SPI W[pƂ */

#define  SPI_MODE16_ON          0xffff  /* SPI W[ 16 rbgf[^舵 */
#define  SPI_MODE16_OFF         0xfbff  /* SPI W[ 8 rbgf[^舵      */

#define  SPI_SMP_ON             0xffff  /* (}X^[[h) SDI ̃f[^ǂݍ݂f[^o͂̍Ō̎_Ƃ */
#define  SPI_SMP_OFF            0xfdff  /* (}X^[[h) SDI ̃f[^ǂݍ݂f[^o͂̒Ԃ̎_Ƃ.
                                           (X[u[hł) SPI_SMP_OFFƂD */

#define  SPI_CKE_ON             0xffff  /* NbNANeBux Idle x֑JڂƂ SDOɃf[^o͂*/
#define  SPI_CKE_OFF            0xfeff  /* NbN idle xANeBux֑JڂƂ SDOɃf[^o͂ */

#define  SLAVE_ENABLE_ON        0xffff  /* (X[u[h) SS1sgpƂ  */
#define  SLAVE_ENABLE_OFF       0xff7f  /* (X[u[h) SS1sdlsƎqCI/OpsƂ   */

#define  CLK_POL_ACTIVE_LOW     0xffff  /* NbN 0 ANeBuxC1  idle xƂ */
#define  CLK_POL_ACTIVE_HIGH    0xffbf  /* NbN 1 ANeBuxC0  Idle xƂ */

#define  MASTER_ENABLE_ON       0xffff  /* }CR SPI W[}X^[i}X^[[hjƂ  */
#define  MASTER_ENABLE_OFF      0xffdf  /* }CR SPI W[X[uiX[u[hjƂ  */

#define  SEC_PRESCAL_1_1        0xffff  /* 2 iڃvXP[ 1/1 Ƃ  */
#define  SEC_PRESCAL_2_1        0xfffb  /* 2 iڃvXP[ 1/2 Ƃ  */
#define  SEC_PRESCAL_3_1        0xfff7  
#define  SEC_PRESCAL_4_1        0xfff3  
#define  SEC_PRESCAL_5_1        0xffef  
#define  SEC_PRESCAL_6_1        0xffeb  
#define  SEC_PRESCAL_7_1        0xffe7  
#define  SEC_PRESCAL_8_1        0xffe3  /* 2 iڃvXP[ 1/8 Ƃ   */

#define  PRI_PRESCAL_1_1        0xffff  /* iڃvXP[ 1/1 Ƃ  */
#define  PRI_PRESCAL_4_1        0xfffe  /* iڃvXP[ 1/4 Ƃ  */
#define  PRI_PRESCAL_16_1       0xfffd  /* iڃvXP[ 1/16 Ƃ  */
#define  PRI_PRESCAL_64_1       0xfffc  /* iڃvXP[ 1/64 Ƃ  */



/* SPI1STAT rbg` */
#define  SPI_ENABLE             0xffff  /* SPI W[gpƂ */
#define  SPI_DISABLE            0x7fff  /* SPI W[gpsƂ */

#define  SPI_IDLE_CON           0xdfff  /* }CR Idle [hɂƂ SPI W[쓮 */
#define  SPI_IDLE_STOP          0xffff  /* }CR Idle [ĥƂ SPI W[~ */ 

#define  SPI_RX_OVFLOW_CLR     0xffbf   /* SPI1BUF ̃I[o[t[tO 0 ƂĂ*/


/* SPI 荞ݒ` */
#define  SPI_INT_EN             0xffff  /* SPI 荞݉    */
#define  SPI_INT_DIS            0xfff7  /* SPI 荞ݕs  */

#define  SPI_INT_PRI_0          0xfff8  /* SPI 荞ݕs */
#define  SPI_INT_PRI_1          0xfff9  /* SPI Dx@Œ */
#define  SPI_INT_PRI_2          0xfffa  
#define  SPI_INT_PRI_3          0xfffb  
#define  SPI_INT_PRI_4          0xfffc  
#define  SPI_INT_PRI_5          0xfffd 
#define  SPI_INT_PRI_6          0xfffe  
#define  SPI_INT_PRI_7          0xffff  /* SPI Dx@ō */

/* SPI荞݁@}N*/
#define EnableIntSPI1                    _SPI1IE = 1
#define DisableIntSPI1                   _SPI1IE = 0
#define SetPriorityIntSPI1(priority)     _SPI1IP = priority

/* SPI ֐vg^Cvi錾j */
void DAConv(unsigned int a, unsigned int b);

