/*********************************************
A/Dϊ+DMA+Ping Pong vO
**********************************************/
#include <p33fj128mc802.h>
#include ".\include\dma802.h"

// foCXRtBM[V
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ


//^C}ݒ
const unsigned int	tsamp1 =  40000;                        // ADϊgݒ@40MHz/tasmp1 = 1kHz
// DMA萔Cobt@Cϐݒ
#define  NUMSAMP 4
unsigned int ADCBufferA[2][2]__attribute__((space(dma), aligned(8)));	// DMAɂA/Dϊʂi[z̐錾
unsigned int ADCBufferB[2][2]__attribute__((space(dma), aligned(8)));
unsigned int DmaBuffer = 0;

void init_SPI(void);
void init_ADC(void);
void init_timer3(void);
void init_DMA1(unsigned int a);
void DAConv2(unsigned int a, unsigned int b);
void DASimulOut(void);

//DMA1荞ݏ֐
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
    unsigned int vAN0out, vAN1out;
    
    if(DmaBuffer == 0)
    {
        vAN0out = ADCBufferA[0][1]<<2;
        vAN1out = ADCBufferA[1][0]<<2;
    }
    else
    {
        vAN0out = ADCBufferB[0][1]<<2;
        vAN1out = ADCBufferB[1][0]<<2;
    }
    DmaBuffer ^= 1;

    DAConv2(vAN1out, 0x7000);			// `lAI
    DAConv2(vAN0out, 0xF000);			// `lBI
    DASimulOut();

	_DMA1IF = 0;					// 荞݃tONA
}


//C֐
int main(void)
 { //PLLݒ
    _PLLPRE   =  0;     // N1 =  2
    _PLLDIV   = 42;     //  M = 44
    _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz

    _SWDTEN = 0;                     //EHb`hbO^C}It
    while(OSCCONbits.LOCK !=1 );     // PLLbN҂

    // |[gݒ
	TRISA = 0x0003;			//  RA0, 1@́@RA2`RA4 o̓|[g
	TRISB = 0x0000;         //  RB0`RB15 o̓|[g

	//SPIp|[gݒ
	_RP11R =  8;			//RP11  SCK (01000) OUTPUT SELECTION FOR REMAPPABLE PIN (RPn)
	_RP10R =  7;			//RP10  SDO  (00111

    // ӃW[ݒ
    init_SPI();
    init_timer3();
    init_ADC();
    init_DMA1(NUMSAMP);

        while(1){}						//C[v
}



