#include <p33fj128mc802.h>
#include ".\include\timer802.h"
#include ".\include\definition_of_constants.h"

// ^C}2ݒ֐
void init_timer2(void)
{
    unsigned int T2CON_set = T2_ON                  & T2_IDLE_STOP 
                            & T2_GATE_OFF           & T2_PS_1_8 
                            & T2_32BIT_MODE_OFF     & T2_SOURCE_INT;

    TMR2  = 0;              /* ^C}2WX^Zbg */
    PR2   = tsamp2 - 1;     /* ^C}2荞ݎݒ */
    T2CON = T2CON_set;   

    unsigned int TM2IntConfig = T2_INT_PRIOR_5      & T2_INT_ON;
	ConfigIntTimer2(TM2IntConfig);        //^C}2ɂ銄荞ݐݒ
}

// ^C}2荞ݐݒ֐
void ConfigIntTimer2(unsigned int config)
{
    _T2IF = 0;                   /* 荞݃tONA */
    _T2IP = (config &0x0007);    /* 荞ݗDxݒ */
    _T2IE = (config &0x0008)>>3; /* 荞݉^sݒ */
}

