/*********************************************
PWMeXgvO
**********************************************/
#include <p33FJ128MC802.h>

// RtBM[Vݒ
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ

// PWM@
const unsigned int 		PWMPeriod = 1000;                       // 40MHz/20kHz/2 (OpgPWM[h)  PWMg@20KHz

//DMA
#define         NUMSAMP 	 1                                  // ADϊI̓]f[^ (dwߒlCdol)
unsigned int    ADCBuffer[NUMSAMP] __attribute__((space(dma))); //ADϊʂDMAɂ]w

void DAConv(unsigned int a, signed int b);
void init_DMA1(unsigned int a);
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);

// DMA1荞ݏ֐(PWMɂgK  ADϊ  DMAf[^]I荞݁j
// f[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
	unsigned int	Vol_com;                    // PWM dwߒl
    
   	_LATB5 = 1;                                 // 14ԃsI

    Vol_com = ADCBuffer[0];                     // ]wߒlǂݏo
    
	// ϐlj^
        DAConv(Vol_com << 2, 0x7000);           // `lAI

	// f[eBݒ	
        P1DC1 = Vol_com << 1;

    _LATB5 = 0; 								// 14ԃs It
	_DMA1IF = 0;								//荞݃tONA
}

//C֐
int main(void)
{
    //PLLݒ
        _PLLPRE   =  0;     // N1 =  2
        _PLLDIV   = 42;     //  M = 44
        _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz
    //EHb`hbO^C}It
        _SWDTEN = 0;        

   	// PLLbN҂
        while(OSCCONbits.LOCK !=1 );

	//|[gݒ
        TRISA = 	0x0001;		// RA0 , RA1 - 5 o̓|[gݒ
        TRISB = 	0x0000;		// RB0-15 o̓|[gݒ
	
	//SPIp|[gݒ
        _RP11R =  8;			//RP11  SCK (01000) Ɋ蓖
        _RP10R =  7;			//RP10  SDO (00111)Ɋ蓖
		
    // ӃW[ݒ
	init_DMA1(NUMSAMP);     // DMAݒ	
	init_SPI();             // SPIݒ
	init_ADC();             // ADCݒ
    init_PWM();             // MCPWM ݒ

	//[v
	while(1){}
}


