#include <p33fj128mc802.h>
#include ".\include\spi802.h"

// SPIW[ݒ֐
void init_SPI(void)
{
    // SPȈݒp[^ NbN20MHz
    unsigned int SPI1CON1_set= ENABLE_SCK_PIN       & ENABLE_SDO_PIN 
                            & SPI_MODE16_ON         & SPI_SMP_ON 
                            & SPI_CKE_OFF           & CLK_POL_ACTIVE_LOW
                            & MASTER_ENABLE_ON      & SEC_PRESCAL_1_1
                            & PRI_PRESCAL_1_1;
    unsigned int SPI1CON2_set = 0x0000; // sgp
    unsigned int SPI1STAT_set = SPI_ENABLE          & SPI_IDLE_STOP 
                            & SPI_RX_OVFLOW_CLR;

    // SPIW[ݒ
     SPI1CON1 = SPI1CON1_set;         
     SPI1CON2 = SPI1CON2_set;
     SPI1STAT = SPI1STAT_set;         
}

// SPI |[gݒ
#define 	SPI_CS		_LATB12		// D/ARo[^ Select
#define 	SPI_LDAC	_LATB13		// D/ARo[^ Load

// DAϊւ̃f[^o͊֐   eϐj^[p
void DAConv(unsigned int Data, unsigned int Command)
{
	int delay;

		SPI_CS = 0;                             // CS Low
		SPI1BUF = (0x0FFF & Data) | Command;	// Command + DataM
		delay = 1;                              //  700 nsecfBC
		while(delay--);                         // MI҂
		SPI_CS = 1;                             // CS High
		SPI_LDAC = 0;                           // LoadpXo
		SPI_LDAC = 1;
}
