// {wb_t@ĆCMicrochipЃIWĩwb_t@Cpwm.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>



/* P1TCON rbg` */
#define PWM1_EN                  0xA0FF  /*PWMW[gp*/
#define PWM1_DIS                 0x20FF  /*PWMW[gps*/

#define PWM1_IDLE_STOP           0xA0FF  /*idle[hɂA/DW[It*/
#define PWM1_IDLE_CON            0x80FF  /*idle[hɂA/DW[I*/

#define PWM1_OP_SCALE1           0xA00F  /* P1TMR = 0ƂȂ^C~OɊ荞  */
#define PWM1_OP_SCALE2           0xA01F  /* P1TMR = 0ƂȂ2ڂ̃^C~OɊ荞  */
#define PWM1_OP_SCALE3           0xA02F  
#define PWM1_OP_SCALE4           0xA03F  
#define PWM1_OP_SCALE5           0xA04F  
#define PWM1_OP_SCALE6           0xA05F  
#define PWM1_OP_SCALE7           0xA06F  
#define PWM1_OP_SCALE8           0xA07F  
#define PWM1_OP_SCALE9           0xA08F  
#define PWM1_OP_SCALE10          0xA09F 
#define PWM1_OP_SCALE11          0xA0AF  
#define PWM1_OP_SCALE12          0xA0BF  
#define PWM1_OP_SCALE13          0xA0CF 
#define PWM1_OP_SCALE14          0xA0DF  
#define PWM1_OP_SCALE15          0xA0EF 
#define PWM1_OP_SCALE16          0xA0FF  /*@P1TMR = 0ƂȂ16ڂ̃^C~OɊ荞  */

#define PWM1_IPCLK_SCALE1        0xA0F3  /*PWM Time Base(PWMW[NbN)foCXCXgNVNbNFcyƂ */
#define PWM1_IPCLK_SCALE4        0xA0F7  /*PWM Time Base(PWMW[NbN)Fcy1^4Ƃ */
#define PWM1_IPCLK_SCALE16       0xA0FB  /*PWM Time Base(PWMW[NbN)Fcy1^16Ƃ */
#define PWM1_IPCLK_SCALE64       0xA0FF  /*PWM Time Base(PWMW[NbN)Fcy1^64Ƃ */

#define PWM1_MOD_FREE            0xA0FC  /*Free Runningîgj[h*/
#define PWM1_MOD_SING            0xA0FD  /*Single Eventîgj[hiPTEN = 1 ƂPWMg`1񂾂o͂āCPTEN = 0 ɃZbgĒ~j*/
#define PWM1_MOD_UPDN            0xA0FE  /*Up/Down CountiOpgj[h */
#define PWM1_MOD_DBL             0xA0FF  /*Up/Down CountiOpgj[hCP1TMR = 0  P1TMR = P1TPER̗Ŋ荞ݎs */


/* PWM1CON1 rbg` */
#define PWM1_MOD3_COMP           0x0BFF  /*PWM1H3PWM1L3complimentary modei⃂[hj*/
#define PWM1_MOD2_COMP           0x0DFF  /*PWM1H2PWM1L2complimentary modei⃂[hj*/
#define PWM1_MOD1_COMP           0x0EFF  /*PWM1H1PWM1L1complimentary modei⃂[hj*/


#define PWM1_MOD3_IND            0x0FFF  /*PWM1H3PWM1L3independent modeiƗ[hj*/
#define PWM1_MOD2_IND            0x0FFF  /*PWM1H2PWM1L2independent modeiƗ[hj*/
#define PWM1_MOD1_IND            0x0FFF  /*PWM1H1PWM1L1independent modeiƗ[hj*/


#define PWM1_PEN3H               0x0FFF  /*PWM1H3PWMo͂Ƃ*/
#define PWM1_PDIS3H              0x0FBF  /*PWM1H3IOpsƂ*/

#define PWM1_PEN2H               0x0FFF  /*PWM1H2PWMo͂Ƃ*/
#define PWM1_PDIS2H              0x0FDF  /*PWM1H2IOpsƂ*/

#define PWM1_PEN1H               0x0FFF  /*PWM1H1PWMo͂Ƃ*/
#define PWM1_PDIS1H              0x0FEF  /*PWM1H1IOpsƂ*/

#define PWM1_PEN3L               0x0FFF  /*PWM1L3PWMo͂Ƃ*/
#define PWM1_PDIS3L              0x0FFB  /*PWM1L3IOpsƂ*/

#define PWM1_PEN2L               0x0FFF  /*PWM1L2PWMo͂Ƃ*/
#define PWM1_PDIS2L              0x0FFD  /*PWM1L2IOpsƂ*/

#define PWM1_PEN1L               0x0FFF  /*PWM1L1PWMo͂Ƃ*/
#define PWM1_PDIS1L              0x0FFE  /*PWM1L1IOpsƂ*/


/* PWM1CON2 rbg` */
#define PWM1_SEVOPS1             0x0003  /*ADϊP1TMR = P1SECMPƂȂ^C~OɎs*/
#define PWM1_SEVOPS2             0x0103  /*ADϊP1TMR = P1SECMPƂȂ2ڂ̃^C~OɎs*/
#define PWM1_SEVOPS3             0x0203  
#define PWM1_SEVOPS4             0x0303  
#define PWM1_SEVOPS5             0x0403  
#define PWM1_SEVOPS6             0x0503  
#define PWM1_SEVOPS7             0x0603  
#define PWM1_SEVOPS8             0x0703  
#define PWM1_SEVOPS9             0x0803  
#define PWM1_SEVOPS10            0x0903  
#define PWM1_SEVOPS11            0x0A03  
#define PWM1_SEVOPS12            0x0B03  
#define PWM1_SEVOPS13            0x0C03  
#define PWM1_SEVOPS14            0x0D03  
#define PWM1_SEVOPS15            0x0E03  
#define PWM1_SEVOPS16            0x0F03  /* ADϊP1TMR = P1SECMPƂȂ16ڂ̃^C~OɎs*/


#define PWM1_OSYNC_PWM           0x0F03  /* P1OVDCONWX^̍XVPWM Time Baseɓ*/
#define PWM1_OSYNC_TCY           0x0F01  /* P1OVDCONWX^̍XVVXeNbNTcyɓ*/

#define PWM1_UDIS                0x0F03  /* P1DCsCPTPER XVs */
#define PWM1_UEN                 0x0F02  /* P1DCsCPTPER XV*/


/* P1DTCON1 rbg` */
// fbh^C̓n[tubWhCoɂăn[hEFAŎĂ邽ߏȗ


/* P1DTCON2 rbg` */
// fbh^C̓n[tubWhCoɂăn[hEFAŎĂ邽ߏȗ


/* P1OVDCON rbg` */
// 120ʓd^3PWMɂėpD{eł͗pȂߏȗ


/* PWM荞݉^sݒ */

#define PWM1_INT_EN              0xFFFF  /*PWM荞݉*/
#define PWM1_INT_DIS             0xFFF7  /*PWM荞ݕs*/


/* Enable/Disable FaultA Interrupt */
// gp


/* Setting the priority of PWM interrupt */
#define PWM1_INT_PR0             0xFFF8  /*PWM荞ݕsgp*/
#define PWM1_INT_PR1             0xFFF9  /*Dx@Œ*/
#define PWM1_INT_PR2             0xFFFA  
#define PWM1_INT_PR3             0xFFFB  
#define PWM1_INT_PR4             0xFFFC 
#define PWM1_INT_PR5             0xFFFD 
#define PWM1_INT_PR6             0xFFFE 
#define PWM1_INT_PR7             0xFFFF  /*Dx@ō*/


/* Setting the priority of PWM FaultA interrupt */
// gp


/* P1FLTACON Register */
// gp


/* PWM荞݁@}N */
#define EnableIntMCPWM                          _PWM1IE = 1
#define DisableIntMCPWM                         _PWM1IE = 0
#define SetPriorityIntMCPWM(priority)           _PWM1IP = priority

#define EnableMCPWMIntFLTA                      _FLTA1IE = 1
#define DisableMCPWMIntFLTA                     _FLTA1IE = 0
#define SetPriorityMCPWMIntFLTA(priority)       _FLTA1IP = priority


/* PWM ֐vg^Cvi錾j */


